<script setup lang="ts">
import { defineProps, defineEmits } from "vue";
import { useForm } from "vee-validate";
import { z } from "zod";
import { toTypedSchema } from "@vee-validate/zod";
import { XMarkIcon } from "@heroicons/vue/24/outline";
import type { TUser } from "../types/user.type";

const props = defineProps<{
  open: boolean;
}>();

const emits = defineEmits<{
  save: [user: TUser];
  close: [];
}>();

const schema = z.object({
  name: z
    .string({ message: "Name is required" })
    .min(3, { message: "Name should at least 3 characters long" }),
  title: z.string({ message: "Title is requried" }),
  email: z.string({ message: "Email is required" }),
  role: z.enum(["MEMBER", "ADMIN", "OWNER"], { message: "Invalid role" }),
});

const { errors, handleSubmit, defineField } = useForm({
  initialValues: {
    name: "",
    title: "",
    email: "",
    role: "MEMBER",
  },
  validationSchema: toTypedSchema(schema),
});

const [name, nameAttrs] = defineField("name");
const [title, titleAttrs] = defineField("title");
const [email, emailAttrs] = defineField("email");
const [role, roleAttrs] = defineField("role");

const onSubmit = handleSubmit((values) => {
  const user: TUser = {
    id: Date.now().toString(),
    ...values,
  };
  emits("save", user);
});
</script>

<template>
  <div class="fixed inset-0 z-30 bg-black/20">
    <div class="relative flex h-full w-full items-center justify-center">
      <dialog
        :open="props.open"
        class="w-[500px] rounded-lg border bg-white focus:outline-sky-400/50"
      >
        <div class="mb-2 flex items-center justify-between p-4">
          <div class="text-xl font-semibold">Add User</div>
          <button
            class="rounded-full p-1 hover:bg-gray-200 focus:outline-none"
            @click="emits('close')"
          >
            <XMarkIcon class="h-5 w-5" />
          </button>
        </div>
        <div class="p-4">
          <form @submit="onSubmit">
            <div class="mb-4">
              <label for="name">Name</label>
              <input
                class="w-full rounded-md border px-2 py-2 transition-colors duration-200 focus:outline-sky-400"
                placeholder="Name"
                v-model="name"
                v-bind="nameAttrs"
              />
              <small v-if="errors.name" class="text-red-500">{{
                errors.name
              }}</small>
            </div>
            <div class="mb-4">
              <label for="title">Title</label>
              <input
                class="w-full rounded-md border px-2 py-2 transition-colors duration-200 focus:outline-sky-400"
                placeholder="Title"
                v-model="title"
                v-bind="titleAttrs"
              />
              <small v-if="errors.title" class="text-red-500">{{
                errors.title
              }}</small>
            </div>
            <div class="mb-4">
              <label for="email">Email</label>
              <input
                type="email"
                class="w-full rounded-md border px-2 py-2 transition-colors duration-200 focus:outline-sky-400"
                placeholder="Email"
                v-model="email"
                v-bind="emailAttrs"
              />
              <small v-if="errors.email" class="text-red-500">{{
                errors.email
              }}</small>
            </div>
            <div class="mb-6">
              <label for="role">Role</label>
              <select
                class="w-full rounded-md border px-2 py-2 transition-colors duration-200 focus:outline-sky-400"
                v-model="role"
                v-bind="roleAttrs"
              >
                <option value="MEMBER">Member</option>
                <option value="ADMIN">Admin</option>
                <option value="OWNER">Owner</option>
              </select>
              <small v-if="errors.role" class="text-red-500">{{
                errors.role
              }}</small>
            </div>
            <button
              class="w-full rounded-md bg-sky-600 px-4 py-2 text-sm font-bold text-white hover:bg-sky-700 focus:outline-none"
            >
              Add User
            </button>
          </form>
        </div>
      </dialog>
    </div>
  </div>
</template>
